#include <stdio.h>
#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/DrawingA.h>

Widget       toplevel, drawa, forma, buttonw, buttonq;

/*  Functions defined in this program  */

void main();
void activateCB();
XtArgVal GetPixel();
void quitCB();
void Action1();    /* Action procedure */
void Action2();    /* Action procedure */
void Action3();    /* Action Procedure */

/* Global variables */
Arg args[10];    /*  arg list             */
int n;           /*  arg count            */
Boolean  activate = True;

/*-------------------------------------------------------------
**  activateCB - activate callback for buttonw
*/
void activateCB (w, client_data, call_data) 
  Widget   w;            /*  widget id              */
  XtPointer   client_data;  /*  data from application  */
  XtPointer   call_data;    /*  data from widget class */

{

  XmString     text1;
  char         *texta = "From Callback activateCB.";
  GC           gc;
  XtGCMask     value_mask;
  XGCValues    values;
  Display      *display;
  Window       win; 
  Dimension    str_width;
  XFontStruct *font1;
  XmFontList   fontlist;

  if (activate) {
  font1 = XLoadQueryFont (XtDisplay(toplevel), "iso1.16b");
  fontlist = XmFontListCreate (font1, "chset1");

  n=0;
  XtSetArg (args[n], XmNfontList, fontlist); n++;
  XtSetValues (drawa, args, n); 

/*  Create a compound string for the first one */
  text1 = XmStringCreate (texta,"chset1");

/*  Draw text1 in the bulletin board */
  display = XtDisplay (drawa);
  win = XtWindow (drawa);

  value_mask = GCBackground | GCForeground | GCFont;
  values.foreground = GetPixel("white");
  values.font = (*(XFontStruct **) fontlist)->fid; 

  str_width = XmStringWidth (fontlist, text1);
  gc = XtGetGC (drawa, value_mask, &values);
  XmStringDraw (display, win, fontlist, text1, gc, 25, 25, str_width, 
  XmALIGNMENT_BEGINNING, XmSTRING_DIRECTION_L_TO_R, NULL);

/*  Free the memory used by the compound string */
  XmStringFree(text1);

  }
}

/*-------------------------------------------------------------
**  GetPixel - Convert string to pixel
*/
static XtArgVal GetPixel(colorstr)
char *colorstr;
{
   XrmValue from, to;

   from.size = strlen(colorstr) +1;
   if (from.size < sizeof(String)) from.size = sizeof(String);
   from.addr = colorstr;
   to.addr = NULL;
   XtConvert(toplevel, XmRString, &from, XmRPixel, &to);

   return ((XtArgVal) *((XtArgVal *) to.addr));
}

/*-------------------------------------------------------------
**  quitCB - callback for quit button
*/
void quitCB (w, client_data, call_data) 
  Widget   w;            /*  widget id              */
  XtPointer   client_data;  /*  data from application  */
  XtPointer   call_data;    /*  data from widget class */

{

/* print message and terminate program  */
  printf ("Terminating Program.\n");
  exit (0);
}

/*-------------------------------------------------------------
**  Action1 - Action procedure mapped to <Btn2Up>   
*/
void Action1 (w, event, params, num_params)
  Widget   w;
  XEvent   *event;
  String   *params;
  Cardinal *num_params;

{
  XmString     text1;
  char         *texta = "From Proc Action1.";
  GC           gc;
  XtGCMask     value_mask;
  XGCValues    values;
  Display      *display;
  Window       win; 
  Dimension    str_width;
  XFontStruct *font1;
  XmFontList   fontlist;

  activate = False; /* Don't want activateCB called */
  if (!XtIsRealized (drawa)) {   /* Don't draw to unrealized widget */
    printf ("Drawing Area widget drawa is not realized.");
    return;
  }
  else { /* Drawing area widget realized; OK to draw on it */
    font1 = XLoadQueryFont (XtDisplay(toplevel), "vgh-25");
    fontlist = XmFontListCreate (font1, "chset1");

    n=0;
    XtSetArg (args[n], XmNfontList, fontlist); n++;
    XtSetValues (drawa, args, n); 

/*  Create a compound string for the text */
    text1 = XmStringCreate (texta,"chset1");

/*  Draw text1 in the drawing area */
    display = XtDisplay (drawa);
    win = XtWindow (drawa);

    value_mask = GCBackground | GCForeground | GCFont;
    values.foreground = GetPixel("white");
    values.font = (*(XFontStruct **) fontlist)->fid; 

    str_width = XmStringWidth (fontlist, text1);
    gc = XtGetGC (drawa, value_mask, &values);
    XmStringDraw (display, win, fontlist, text1, gc, 25, 75, str_width, 
      XmALIGNMENT_BEGINNING, XmSTRING_DIRECTION_L_TO_R, NULL);

/*  Free the memory used by the compound string */
    XmStringFree(text1);
  }
}

/*-------------------------------------------------------------
**  Action2 - Action procedure mapped to <Btn3Up>  
*/
void Action2 (w, event, params, num_params)
  Widget   w;
  XEvent   *event;
  String   *params;
  Cardinal *num_params;

{
  XmString     text1;
  char         *texta = "From Proc Action2.";
  GC           gc;
  XtGCMask     value_mask;
  XGCValues    values;
  Display      *display;
  Window       win; 
  Dimension    str_width;
  XFontStruct *font1;
  XmFontList   fontlist;
  
  activate = False; /* Don't want activateCB called */
  if (!XtIsRealized (drawa)) {   /* Don't draw to unrealized widget */
    printf ("Drawing Area widget drawa is not realized.");
    return;
  }
  else { /* Drawing area widget realized; OK to draw on it */
    font1 = XLoadQueryFont (XtDisplay(toplevel), "iso1.8");
    fontlist = XmFontListCreate (font1, "chset1");

    n=0;
    XtSetArg (args[n], XmNfontList, fontlist); n++;
    XtSetValues (drawa, args, n); 

/*  Create a compound string for the text */
    text1 = XmStringCreate (texta,"chset1");

/*  Draw text1 in the drawing area */
    display = XtDisplay (drawa);
    win = XtWindow (drawa);
    value_mask = GCBackground | GCForeground | GCFont;
    values.foreground = GetPixel("white");
    values.font = (*(XFontStruct **) fontlist)->fid; 
    str_width = XmStringWidth (fontlist, text1);
    gc = XtGetGC (drawa, value_mask, &values);
    XmStringDraw (display, win, fontlist, text1, gc, 25, 125, str_width, 
    XmALIGNMENT_BEGINNING, XmSTRING_DIRECTION_L_TO_R, NULL);

/*  Free the memory used by the compound string */
    XmStringFree(text1);
  }
}

/*-------------------------------------------------------------
**  Action3 - Action procedure mapped to <Btn3Up>  
*/
void Action3 (w, event, params, num_params)
  Widget   w;
  XEvent   *event;
  String   *params;
  Cardinal *num_params;

{
  activate = True;
}

/*----------------------------------------------------------------
**  main - Main logic for drawacts.c
*/
void main (argc,argv)
unsigned int argc;
char **argv;

{
XtAppContext app_context; /*  application context  */

/* Action table declares Action1 and Action2 as action procedures */
static XtActionsRec acts[] = {
{"Action1", Action1},
{"Action2", Action2},
{"Action3", Action3}
};

/* Translation table correlates the action procedures with event sequences */
static XtTranslations  parsed_xlations; 

static char addXlations[] = "\
#augment<Btn2Down>:  Arm()\n\
<Btn2Up>: Action1() Activate() Disarm() Action3()\n\
<Btn3Down>: Arm()\n\
<Btn3Up>:  Action2() Activate() Disarm() Action3()\n\
<EnterWindow>:  Enter()\n\
<LeaveWindow>:  Leave()";

/*  Initialize the toolkit, create application context, open display, 
    and  create a toplevel shell */
  toplevel = XtAppInitialize (&app_context, "Drawacts", NULL, 0, &argc, argv,
  NULL, args, 0);

/*  Add the actions table */
  XtAppAddActions (app_context, acts, XtNumber (acts));

/*  Parse the translation table */
  parsed_xlations = XtParseTranslationTable (addXlations); 

/*  Create a Form */
  n = 0;
  forma = XmCreateForm (toplevel, "forma", args, n);

/*  Manage the Form widget */
  XtManageChild (forma);

/*  Create a drawing area widget */
  n = 0;
  drawa = XmCreateDrawingArea (forma, "drawa", args, n);

/*  Manage the drawing area widget */ 
  XtManageChild (drawa); 

/*  Create a push button widget for the write button*/
  n = 0;
  XtSetArg (args[n], XmNtranslations, parsed_xlations); n++; 
  buttonw = XmCreatePushButton (forma, "buttonw", args, n);
  XtManageChild (buttonw);

/*  Add callback for the write button */
  XtAddCallback (buttonw, XmNactivateCallback, activateCB, NULL);

/*  Create another push button widget for the quit button */
  n = 0;
  buttonq = XmCreatePushButton (forma, "buttonq", args, n);
  XtManageChild (buttonq);

/*  Add a callback for the quit button */
  XtAddCallback (buttonq, XmNactivateCallback, quitCB, NULL);

/*  Realize widgets  */
  XtRealizeWidget (toplevel);

/*  Process events  */
  XtAppMainLoop (app_context);
}
